#ifndef FUNCTIONS_STRTOFLOAT
#define FUNCTIONS_STRTOFLOAT

#ifndef FUNCTIONS_STRTOINT
#include <pandora/functions/strtoint.c>
#endif

static DOUBLE StrToFloat(STRING String)
{
   DOUBLE Result;
   LONG Factor;
   LONG Number;

   if (!String) return(0);

   /*** Ignore any leading characters ***/

   while ((*String != '-') AND ((*String < '0') OR (*String > '9'))) {
      if (*String IS 0) return(0);
      String++;
   }

   Result = (DOUBLE)StrToInt(String);

   /*** Skip numbers ***/
   if (*String IS '-') String++;
   while ((*String >= '0') AND (*String <= '9')) String++;

   /*** Check for decimal place ***/
   if (*String IS '.') {
      String++;
      if ((*String >= '0') AND (*String <= '9')) {
         if ((Number = StrToInt(String))) {
             Factor = 1;
             while ((*String >= '0') AND (*String <= '9')) {
                Factor = Factor * 10;
                String++;
             }
             if (Result < 0) {
                Result = Result - (((DOUBLE)Number) / Factor);
             }
             else Result = Result + (((DOUBLE)Number) / Factor);
         }
      }
   }

   return(Result);
}

#endif /* FUNCTIONS_STRTOFLOAT */
